/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package es.ua.jtech.pruebacluster.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;

/**
 *
 * @author especialista
 */
public class Consulta extends HttpServlet {

    @Resource(mappedName = "jdbc/cluster")
    DataSource clusterDS;

    /**
     * Processes requests for both HTTP
     * <code>GET</code> and
     * <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {


        String usuario = null;
        String paramUsuario = null;
        String salir = null;

        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            /*
             * TODO output your page here. You may use following sample code.
             */
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet Consulta de la lista de la compra</title>");
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet Consulta at " + System.getProperty("weblogic.Name") + " " + request.getContextPath() + "</h1>");


            salir = (String) request.getParameter("salir");
            if (salir == null) {
                paramUsuario = (String) request.getParameter("usuario");              
                if (paramUsuario != null && !paramUsuario.isEmpty()) {
                    request.getSession().setAttribute("usuario", paramUsuario);
                }
            } else {
                request.getSession().setAttribute("usuario", null);
            }
            usuario = (String) request.getSession().getAttribute("usuario");            
            if (usuario != null && !usuario.isEmpty()) {
                listaCompra(out, usuario);
            } else {
                solicitaUsuario(out);
            }

            out.println("</form>");
            out.println("</body>");
            out.println("</html>");
        } finally {
            out.close();
        }
    }

    private void solicitaUsuario(PrintWriter out) {


        out.println("<form method='POST' action='Consulta'>");
        out.println("<label for='usuario'>Introduzca su nombre:</label>");
        out.println("<input type='text' id='usuario' name='usuario'/><br><br>");
        out.println("<input type='submit' value='Acceder'/>");
        out.println("</form>");

    }

    private void listaCompra(PrintWriter out, String usuario) {
        Connection conn = null;
        Statement stmt = null;
        out.println("<h2>Usuario: "+ usuario+"</h2>");
        out.println("<h2>La lista</h2>");

        String query = "select * from listaCompra";
        try {
            conn = clusterDS.getConnection();
            stmt = conn.createStatement();

            ResultSet rs = stmt.executeQuery(query);


            while (rs.next()) {
                out.println(rs.getInt("cantidad") + " " + rs.getString("articulo") + "<br/>");
            }

        } catch (SQLException ex) {
            Logger.getLogger(Consulta.class.getName()).log(Level.SEVERE, null, ex);

        } finally {
            try {
                if (stmt != null) {
                    stmt.close();
                }
                if (conn != null) {
                    conn.close();
                }
            } catch (SQLException ex) {
                Logger.getLogger(Consulta.class.getName()).log(Level.SEVERE, null, ex);

            }
        }

        out.println("<form method='POST' action='Consulta'>");
        out.println("<input type='hidden' id='salir' name='salir' value='1'/><br><br>");
        out.println("<input type='submit' value='Salir'/>");
    }
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">

    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
